<template>
  <div>
    <v-card>
      <v-card-title>
        <span class="headline">Locker {{ formDialog.title }}</span>
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-form ref="form" v-model="valid" lazy-validation>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  v-model="value"
                  label="Password*"
                  outlined
                  dense
                  :rules="passwordRules"
                  type="password"
                  required
                ></v-text-field>
              </v-col>
              <!-- <v-col cols="12" align="center">
                <v-btn @click="hide = !hide">
                  <v-icon>keyboard_hide</v-icon>
                </v-btn>
              </v-col> -->
              <v-col cols="12">
                <div
                  class="vuertual-numeric-keyboard bg-light rounded border p-3"
                >
                  <v-btn
                    v-for="key in keys"
                    :key="key"
                    @click="press(key)"
                    color="primary"
                    :class="keyTheme"
                    >{{ key }}</v-btn
                  >
                  <v-btn color="error" @click="clear()">&larr;</v-btn>
                  <v-btn color="error" @click="clear('all')">Clear</v-btn>
                </div>
              </v-col>
            </v-row>
          </v-form>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="checkLogin(value, formDialog)"
          >Login</v-btn
        >
        <v-btn color="blue darken-1" text @click="close">Close</v-btn>
      </v-card-actions>
    </v-card>
    <v-snackbar :color="color" v-model="snackbar" :timeout="timeout" right top>
      {{ text }}
      <template v-slot:action="{ attrs }">
        <v-btn text v-bind="attrs" @click="snackbar = false">Close</v-btn>
      </template>
    </v-snackbar>
  </div>
</template>

<script>
import _ from "lodash";
import axios from "axios";
import { BASEURL } from "../../config/index";

export default {
  name: "AddDialog",
  data() {
    return {
      value: "",
      hide: false,
      keys: [...Array(10).keys()],
      keyTheme: "btn-keyboard",
      valid: true,
      passwordRules: [(v) => !!v || "password is required"],
      snackbar: false,
      text: "",
      timeout: 2000,
      color: "",
      state: 0,
    };
  },
  methods: {
    // shuffle() {
    //   this.keys = _.shuffle(this.keys);
    // },
    press(key) {
      this.value = `${this.value}${key}`;
      // this.shuffle();
    },
    clear(type) {
      if (type === "all") this.value = "";
      else this.value = this.value.substring(0, this.value.length - 1);
    },
    close() {
      this.$emit("close", false);
      this.hide = false;
      this.$refs.form.reset();
      this.value = "";
    },
    async checkLogin(event, formDialogInfo) {
      if (this.$refs.form.validate() == true) {
        // let request = await axios.get(
        //   `${API_URL}/embbed/command/2?password=${event}`
        // );
        let data = {
          lkRoomId: formDialogInfo.lkRoomId,
          passCode: event,
        };
        await this.$store.dispatch("locker/openLocker", data);
        let check = this.$store.getters["locker/openStatus"];
        if (check.status == "S" && this.state == 0) {
          formDialogInfo.subtitleThai = "จองแล้ว";
          formDialogInfo.subtitleEng = "booking";
          formDialogInfo.status = "B";
          this.$emit("login", formDialogInfo);
          this.$refs.form.reset();
          this.value = "";
          this.state = 1;
        } else if (check.status == "S" && this.state == 1) {
          formDialogInfo.subtitleThai = "ว่าง";
          formDialogInfo.subtitleEng = "available";
          formDialogInfo.status = "A";
          this.$emit("login", formDialogInfo);
          this.$refs.form.reset();
          this.value = "";
          this.state = 0;
        } else if (check == 401) {
          this.$emit("login", 401);
        } else {
          this.$emit("login", false);
        }
      }
    },
  },
  props: ["formDialog"],
};
</script>

<style>
.vuertual-numeric-keyboard {
  display: grid;
  grid-template-columns: auto auto auto;
  grid-gap: 10px;
}
.vuertual-numeric-keyboard .btn {
  font-weight: bold;
}
.btn-keyboard {
  background-color: #80b6ff;
  color: #ffffff;
}
</style>
